Subject: [Uri-review] 'ftp' and 'file' URI schemes still needs specifying

From: Mykyta Yevstifeyev <[email-masked]>
Date: Sun, 15 May 2011 08:14:05 +0300

Hello all,

The first mention of 'ftp' URI scheme in the IETF document is probably 
RFC 1738 (http://tools.ietf.org/html/rfc1738), if I'm right.  As far as 
you can see, this RFC is formally obsoleted by RFC 4248 and RFC 4266, 
but in fact RFC 2396 et seq., meaning RFC 3986 (formally they updated 
RFC 1738), replaced it.  Among other, RFC 1738 document specified 
several URI schemes, such as widely-used 'http', 'mailto' etc.  This 
table summarizes the state of schemes specified by RFC 1738.  
("Specification" is the most current RFC defining some scheme).

/Scheme name
/ 	/Protocol
/ 	/Specification
/
http
	HTTP (RFC2616)
	RFC 2616
gopher
	Gopher (RFC1436)
	RFC 4266
mailto
	N/A
	RFC 6068
news
	NNTP (RFC 3977)
	RFC 5538
nntp
	NNTP (RFC 3977)
	RFC 5538
telnet
	Telnet (RFC 854)
	RFC 4248
wais
	WAIS (RFC 1625)
	RFC 4156
file
	N/A
	*RFC 1738*
prospero
	Propsero (non-IETF)
	RFC 4157
ftp
	FTP (RFC 959)
	*RFC 1738
*

:
You may see, there are two schemes in this list specified by formally 
obsoleted RFC 1738 (even though it is actually PS).  They're probably 
the only two schemes (not considering 'afs', but it's in provisional 
regsitry) that are listed at IANA registry, in the Permanent category, 
with a reference to obsoleted RFC (maybe, 'fax' can be considered to be 
so as well; but is it de facto deprecated and hsitorical).  'ftp' and 
'file' schemes are quite widely-used; obsolete RFC 1738 is an actual 
specification for them.

There has been an effort to specify this schemes in separate docs. 
(https://datatracker.ietf.org/doc/draft-hoffman-ftp-uri/, 
https://datatracker.ietf.org/doc/draft-hoffman-file-uri/), but they 
resulted in nothing (unlike eg. RFC 4248, as a part of the same effort, 
if I'm right).  Considering this, should an attempt to provide these 
schemes an up-to-date specification be undertaken?

Mykyta Yevstifeyev

---

From: "Martin J. Dürst" <[email-masked]>
Date: Sun, 15 May 2011 17:20:47 +0900

Hello Mykyta,

Providing specifications for ftp: and file: would indeed be a good 
thing. But please be aware that besides the explicit publications you 
found, there have also been other efforts to specify these schemes, and 
they never got very far. Of the two, I'd guess ftp: is easier, but I 
might be wrong. I definitely know that the file: scheme will be tough; 
there is quite some variation among browsers, not to mention other 
software, and it will be difficult to provide the right balance between 
prescriptive and descriptive approach.

Regards,   Martin.

On 2011/05/15 14:14, Mykyta Yevstifeyev wrote:
> RFC 1738), replaced it. Among other, RFC 1738 document specified several
> URI schemes, such as widely-used 'http', 'mailto' etc. This table
> summarizes the state of schemes specified by RFC 1738. ("Specification"
> is the most current RFC defining some scheme).
>
> /Scheme name
> / /Protocol
> / /Specification
> /
> http
> HTTP (RFC2616)
> RFC 2616
> gopher
> Gopher (RFC1436)
> RFC 4266
> mailto
> N/A
> RFC 6068
> news
> NNTP (RFC 3977)
> RFC 5538
> nntp
> NNTP (RFC 3977)
> RFC 5538
> telnet
> Telnet (RFC 854)
> RFC 4248
> wais
> WAIS (RFC 1625)
> RFC 4156
> file
> N/A
> *RFC 1738*
> prospero
> Propsero (non-IETF)
> RFC 4157
> ftp
> FTP (RFC 959)
> *RFC 1738
> *
>
> :
> obsoleted RFC 1738 (even though it is actually PS). They're probably the
> only two schemes (not considering 'afs', but it's in provisional
> _______________________________________________
> Uri-review mailing list
> [email-masked]
> https://www.ietf.org/mailman/listinfo/uri-review

---

From: Mykyta Yevstifeyev <[email-masked]>
Date: Sun, 15 May 2011 13:29:17 +0300

15.05.2011 11:20, "Martin J. Dürst" wrote:
> found, there have also been other efforts to specify these schemes, 
> and they never got very far. Of the two, I'd guess ftp: is easier, but 
> I might be wrong. I definitely know that the file: scheme will be 
> tough; there is quite some variation among browsers, not to mention 
> other software, and it will be difficult to provide the right balance 
> between prescriptive and descriptive approach.
Thanks for response, Martin.  I recall some discussions on [email-masked] 
list regarding the 'file' URI scheme and can say it is really hard to 
specify it; that person who will undertake this work should probably 
spend a large amount of time on investigation of the issue and putting 
this on paper.  Maybe the difficulty is a great number of variants 
existing for file URIs, ie. absence of unified syntax, first of all.  
The situation is radically different with ftp; there is one well-known 
and widely-accepted syntax of it.  After we'll have defined these two 
schemes, it will make sense to change RFC 1738's status to Historic, 
considering anything of its content will be "shared" between other 
documents, but file URI scheme will be stumbling block here.

Mykyta Yevstifeyev

---

From: Graham Klyne <[email-masked]>
Date: Mon, 16 May 2011 10:26:04 +0100

I distantly recall that the working group that led to RFC 3986 spun out some
activities, or at least proposed such, to try to regularize both ftp: and file:.

I have a recollection  that Paul Hoffman edited a round or two of Internet
Drafts, but the effort ran out of steam.  I also recall a suggestion that rather
than trying to standardize file:, a useful step would be to describe the
varieties of existing behaviours as an informational document, but again there
was no-one with the time and/or energy to push this forward.

To give a sense of timeframe for these discussions, the most recent message
about specific activities (or not) that I can find is:

   http://lists.w3.org/Archives/Public/uri/2004Feb/0014.html

In response to this message (from yours truly) that gives some sense of the 
discussion around file: URIs:

   http://lists.w3.org/Archives/Public/uri/2004Feb/0011.html

After that, I'm not seeing much directed discussion.

#g
--